g = love.graphics

function love.load()
--Player's coords
x1=100
y1=100
w1=10
h1=10
--Object's coords
x2=400
y2=300
w2=30
h2=30

-- collision function
function CheckCollision(x1a,y1a,w1a,h1a, x2a,y2a,w2a,h2a)
			return 	x1a < x2a+w2a and --from right
					x2a < x1a+w1a and --from left
					y1a < y2a+h2a and --from up 
					y2a < y1a+h1a -- from down
	end
-- Player's velocity
lvel=100
rvel=100
dvel=100
uvel=100

-- Object's velocity
x2vel = 10
y2vel =0

-- movement directions, not used in anything important now
	go_left = false
	go_right = false
	go_up = false
	go_down = false
end

function love.update(dt)

-- movement function
		if love.keyboard.isDown("right") then
			x1= x1 + (rvel * dt)
			go_right=true
		end

		if love.keyboard.isDown("left") then
			x1 = x1 - (lvel * dt)
			go_left=true
		end

		if love.keyboard.isDown("down") then
			y1 = y1 + (dvel * dt)
			go_down=true
		end
	
		if love.keyboard.isDown("up") then
			y1 = y1 - (uvel * dt)
			go_up=true
		end

		--Player-Object collision check and reaction
		if CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2) == true then
			if x1+(w1/2) <= x2 then
				rvel=0
			end
			if x1+(w1/2) >= x2 then
				lvel=0
			end
			if y1+(h1/2) <= y2 then
				dvel=0
			end
			if y1+(h1/2) >= y2 then
				uvel=0
			end
			-- Player pushed by Object if collided
			if x2move == true then
				x1 = x1 + x2vel * dt
				y1 = y1 + y2vel * dt
			end
		end
		--resets velocity if Player not collided with Object or Map boundaries
		if CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2) == false and mapcol == false then
			lvel=100
			rvel=100
			dvel=100
			uvel=100
		end
		
-- Map boundaries collision and reactions
if x1 <= 1 then
	lvel=0
	mapcol = true
	else mapcol = false
end
if x1 +w1 >= 799 then
	rvel=0
	mapcol = true
	else mapcol = false
end
if y1 <= 1 then

	uvel=0
	mapcol = true
	else mapcol = false
end
if y1 +h1 >= 599 then
	dvel=0
	mapcol = true
	else mapcol = false
end

-- Object's movement
x2move = true
x2 =  x2 + x2vel * dt
y2 =  y2 + y2vel * dt

end


function love.draw()
-- Player and Object drawing
g.rectangle("line", x1, y1, w1, h1)
g.rectangle("line", x2, y2, w2, h2)


end